'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

exports.__esModule = true;

var _log4js = require('log4js');

var _log4js2 = _interopRequireDefault(_log4js);

var _appAppender = require('./appAppender');

var _appAppender2 = _interopRequireDefault(_appAppender);

var _networkAppender = require('./networkAppender');

var _networkAppender2 = _interopRequireDefault(_networkAppender);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Logger = function () {
  function Logger() {
    (0, _classCallCheck3.default)(this, Logger);
  }

  Logger.createLoggerFactory = function createLoggerFactory() {
    _log4js2.default.configure({
      appenders: [_appAppender2.default, _networkAppender2.default]
    });
    return _log4js2.default;
  };

  Logger.getLogger = function getLogger() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var logger = Logger.LOGGER_FACTORY.getLogger(options.category || 'app');
    logger.setLevel(options.level);
    if (options.replaceConsole) {
      Logger.LOGGER_FACTORY.replaceConsole(logger);
    }
    return logger;
  };

  Logger.middleware = function middleware() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var logger = Logger.LOGGER_FACTORY.getLogger(options.category || 'network');
    var level = options.level || 'auto';
    var format = options.format || ':method :url :status :content-length - :response-time ms';
    return _log4js2.default.connectLogger(logger, { level: level, format: format });
  };

  Logger.addAppender = function addAppender(appender) {
    return Logger.LOGGER_FACTORY.addAppender(appender);
  };

  return Logger;
}();

Logger.LOGGER_FACTORY = Logger.createLoggerFactory();
exports.default = Logger;
//# sourceMappingURL=Logger.js.map