'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

exports.__esModule = true;

var _graphite = require('graphite');

var _graphite2 = _interopRequireDefault(_graphite);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var MetricsSender = function () {
  function MetricsSender() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    (0, _classCallCheck3.default)(this, MetricsSender);

    if (!options.graphite) {
      throw new Error('graphite information is required.');
    }
    this.client = _graphite2.default.createClient('plaintext://' + options.graphite.host + ':' + options.graphite.port + '/');
  }

  MetricsSender.prototype.send = function send(metrics) {
    this.client.write(metrics, function (error) {
      if (error) {
        console.error('Metrics sent failed: ', error);
      }
    });
  };

  return MetricsSender;
}();

exports.default = MetricsSender;
//# sourceMappingURL=MetricsSender.js.map