'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

exports.__esModule = true;

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _cluster = require('cluster');

var _cluster2 = _interopRequireDefault(_cluster);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var Metrics = function () {
  function Metrics() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    (0, _classCallCheck3.default)(this, Metrics);

    this.project = options.project || process.env.npm_package_project || 'unnamed';
    this.service = options.service || process.env.npm_package_name || 'unnamed';
    this.clusterId = _cluster2.default.isWorker ? _cluster2.default.worker.id : 'master';
    this.prefix = ['hosts', this.project, this.service, _os2.default.hostname(), this.clusterId, 'node'].join('.');
    this.id = options.id || '';
    this.metrics = options.metrics || 0;
  }

  Metrics.prototype.getMetricsKey = function getMetricsKey() {
    return this.prefix + '.' + this.id;
  };

  Metrics.prototype.getMetricsValue = function getMetricsValue() {
    return this.metrics;
  };

  Metrics.prototype.getMetrics = function getMetrics() {
    var metrics = {};
    metrics[this.getMetricsKey()] = this.getMetricsValue();
    return metrics;
  };

  return Metrics;
}();

exports.default = Metrics;
//# sourceMappingURL=Metrics.js.map