'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.__esModule = true;

var _gcStats = require('gc-stats');

var _gcStats2 = _interopRequireDefault(_gcStats);

var _Metrics2 = require('../Metrics');

var _Metrics3 = _interopRequireDefault(_Metrics2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var GarbageCollectionMetrics = function (_Metrics) {
  (0, _inherits3.default)(GarbageCollectionMetrics, _Metrics);

  function GarbageCollectionMetrics() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    (0, _classCallCheck3.default)(this, GarbageCollectionMetrics);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Metrics.call(this, options));

    _this.id = 'gc';
    _this.gc = (0, _gcStats2.default)();
    _this.sender = options.sender;
    _this.gc.on('stats', function (stats) {
      _this.sender.send(_this.getMetrics(stats));
    });
    return _this;
  }

  GarbageCollectionMetrics.prototype.getMetrics = function getMetrics(stats) {
    var metrics = {};
    var gcType = this.getGCType(stats.gctype);
    var key = this.getMetricsKey() + '.' + gcType;
    metrics[key] = stats.pauseMS;
    return metrics;
  };

  GarbageCollectionMetrics.prototype.getGCType = function getGCType(type) {
    switch (type) {
      case 1:
        return 'minor';
      case 2:
      case 3:
        return 'major';
      default:
        return '';
    }
  };

  return GarbageCollectionMetrics;
}(_Metrics3.default);

exports.default = GarbageCollectionMetrics;
//# sourceMappingURL=GarbageCollectionMetrics.js.map