'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.__esModule = true;

var _memwatchNext = require('memwatch-next');

var _memwatchNext2 = _interopRequireDefault(_memwatchNext);

var _heapdump = require('heapdump');

var _heapdump2 = _interopRequireDefault(_heapdump);

var _Metrics2 = require('../Metrics');

var _Metrics3 = _interopRequireDefault(_Metrics2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var MemoryLeakMetrics = function (_Metrics) {
  (0, _inherits3.default)(MemoryLeakMetrics, _Metrics);

  function MemoryLeakMetrics() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    (0, _classCallCheck3.default)(this, MemoryLeakMetrics);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Metrics.call(this, options));

    _this.id = 'memory.leak';
    _this.sender = options.sender;
    _this.autoDump = options.autoDump || false;

    _memwatchNext2.default.on('leak', function (stats) {
      console.warn('Detected Memory Leaks', stats);
      _this.sender.send(_this.getMetrics(stats.growth));

      if (_this.autoDump) {
        _heapdump2.default.writeSnapshot(function (err, filename) {
          if (err) {
            console.error('Heap Dump Failed', err);
            return;
          }
          console.warn('Heap Dump Written To', filename);
        });
      }
    });
    return _this;
  }

  MemoryLeakMetrics.prototype.getMetrics = function getMetrics(stats) {
    var metrics = {};
    metrics[this.getMetricsKey()] = stats.growth;
    return metrics;
  };

  return MemoryLeakMetrics;
}(_Metrics3.default);

exports.default = MemoryLeakMetrics;
//# sourceMappingURL=MemoryLeakMetrics.js.map